Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/FrmRegField.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/FrmRegField.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/Request/FrmRegField.cs	(revision 51)
@@ -0,0 +1,591 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using ProcessManagement.DataModel;
+using ProcessManagement.Common;
+using ProcessManagement.Forms.SubForms;
+using System.Collections;
+
+namespace ProcessManagement.Forms.DataEntry
+{
+    public partial class FrmRegField : Form
+    {
+        #region ログ使用定義
+        //log4netログを使用する
+        private static readonly log4net.ILog logger = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 列インデックスenum
+        /// </summary>
+        private enum ColumnIndex
+        {
+            ConstructionCode,           // 現場コード (非表示)
+            No,                         // 行番号
+            ConstructionName,           // 現場名
+            BillPrice,                  // 金額
+            ReadOnly,
+        }
+        #endregion
+
+        #region 変数
+        /// <summary>
+        /// 請求書データ
+        /// </summary>
+        private ConstructionFieldNameHeader m_ConstructionFieldNameHeader = new ConstructionFieldNameHeader();
+
+        /// <summary>
+        /// 請求書明細のConstructionCodeをキーとしたハッシュテーブル
+        /// </summary>
+        private Hashtable m_HtDetailLineCount = new Hashtable();
+
+        /// <summary>
+        /// 他担当の現場割当済金額
+        /// </summary>
+        private int m_UnknownReservedPrice = 0;
+
+        /// <summary>
+        /// 終了状態フラグ
+        /// </summary>
+        private DialogResult m_EndButton = DialogResult.None;
+
+        /// <summary>
+        /// Grid行のハッシュテーブル
+        /// </summary>
+        private Hashtable m_HtGridRowConstructionCode = new Hashtable();
+        #endregion
+
+        #region プロパティ
+        /// <summary>
+        /// 請求書データ
+        /// </summary>
+        public ConstructionFieldNameHeader ConstructionFieldNameHeader
+        {
+            get { return m_ConstructionFieldNameHeader; }
+            set { m_ConstructionFieldNameHeader = value; }
+        }
+
+        /// <summary>
+        /// 終了ボタン押下
+        /// </summary>
+        public DialogResult EndButton
+        {
+            get { return m_EndButton; }
+        }
+        #endregion
+
+        #region フォーム初期化
+        /// <summary>
+        /// フォーム初期化
+        /// </summary>
+        public FrmRegField()
+        {
+            InitializeComponent();
+        }
+        #endregion
+
+        #region フォームロード
+        /// <summary>
+        /// フォームロード
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void FrmRegField_Load(object sender, EventArgs e)
+        {
+            //フォームサイズ固定
+            this.MaximizedBounds = new Rectangle(this.Left, this.Top, this.Width, this.Height);
+            // 初期表示
+            InitDataLoad();
+        }
+        #endregion
+
+        #region 現場追加ボタン押下
+        /// <summary>
+        /// 現場追加ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnAdd_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                // 現場選択画面を初期化
+                FrmConstructionDiag frmConstructionDiag = new FrmConstructionDiag();
+                frmConstructionDiag.PersonCode = CommonMotions.LoginUserData.PersonCode;
+                frmConstructionDiag.PersonCharge = (int)FrmConstructionDiag.PersonChargePoint.Construction; //関連工事のみ表示する
+
+                // 現場選択画面表示
+                frmConstructionDiag.ShowDialog();
+
+                // 選択結果判定 OKなら以下の処理を実行する
+                if (frmConstructionDiag.EndButton == DialogResult.OK)
+                {
+                    // 同じ現場コードの行を探す
+                    if (!m_HtGridRowConstructionCode.ContainsKey(frmConstructionDiag.ConstructionCode))
+                    {
+                        // 見つからなかった場合は現場を追加
+
+                        // 行番号付番
+                        int rowCount = dgv1.RowCount - 1;
+
+                        // 現場の追加
+                        dgv1.Rows.Add(frmConstructionDiag.ConstructionCode, rowCount, frmConstructionDiag.ConstructionName, 0, false);
+                        dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+                        dgv1[(int)ColumnIndex.BillPrice, dgv1.RowCount - 1].ReadOnly = false;
+                        //dgv1[(int)ColumnIndex.BillPrice, dgv1.RowCount - 1].Style.Format = "#,0";
+
+                        // ハッシュテーブルに追加
+                        m_HtGridRowConstructionCode.Add(frmConstructionDiag.ConstructionCode, dgv1.Rows[dgv1.RowCount - 1]);
+                    }
+
+                }
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 現場削除ボタン押下
+        /// <summary>
+        /// 現場削除ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnDelete_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                foreach (DataGridViewRow gridRow in dgv1.SelectedRows)
+                {
+                    // ハッシュテーブルから選択行を削除する
+                    m_HtGridRowConstructionCode.Remove((int)gridRow.Cells[(int)ColumnIndex.ConstructionCode].Value);
+
+                    // Gridから選択行を削除する
+                    dgv1.Rows.Remove(gridRow);
+
+                }
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+
+                // 行番号を再付番
+                for (int rowIndex = 0; rowIndex < dgv1.RowCount - 2; rowIndex++ )
+                {
+                    dgv1.Rows[rowIndex + 2].Cells[(int)ColumnIndex.No].Value = rowIndex + 1;
+                }
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+                dgv1.ClearSelection();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 登録ボタン押下
+        /// <summary>
+        /// 登録ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnAccept_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                int maxLineCount = 0;
+
+                if (CommonMotions.cnvInt(dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value) < 0)
+                {
+                    MessageBox.Show("入力金額が請求書金額を超えています。", "データ確認", MessageBoxButtons.OK, MessageBoxIcon.Warning);
+                    return;
+                }
+
+                // 初期化時に受け取ったデータからの変更を検出する処理
+                foreach (var detail in m_ConstructionFieldNameHeader.ConstructionFieldNameDetails)
+                {
+                    // 最大LineCountを取得
+                    maxLineCount = (maxLineCount < detail.LineCount) ? detail.LineCount : maxLineCount;
+
+                    // 不明のデータ
+                    if(detail.ConstructionCode == 0)
+                    {
+                        // 不明のデータは後回し
+                        continue;
+                    }
+
+                    if (m_HtGridRowConstructionCode.ContainsKey(detail.ConstructionCode))
+                    {
+                        var gridRow = m_HtGridRowConstructionCode[detail.ConstructionCode] as DataGridViewRow;
+
+                        // 見つかったら 金額を取得、行を削除する
+                        detail.BillPrice = CommonMotions.cnvInt(gridRow.Cells[(int)ColumnIndex.BillPrice].Value);
+                        if (detail.BillPrice == 0)
+                        {
+                            // 金額が0となっている場合は削除フラグをtrueにする
+                            detail.DeleteFlag = true;
+                        }
+                        dgv1.Rows.Remove(gridRow);
+                    }
+                    else
+                    {
+                        // 見つからない場合は、削除フラグをtrueにする
+                        detail.DeleteFlag = true;
+                        detail.BillPrice = 0;
+                    }
+
+                }
+
+                // 新規に追加されたデータの処理
+                for (int rowIndex = 0; rowIndex < dgv1.RowCount - 2; rowIndex++ )
+                {
+                    // 他担当者の割当済行の次の行からを対象とする
+                    var rowData = dgv1.Rows[rowIndex + 2];
+
+                    // 金額が0のものは処理対象外
+                    if (CommonMotions.cnvInt(rowData.Cells[(int)ColumnIndex.BillPrice].Value) != 0)
+                    {
+                        // 画面上で追加された現場データを追加
+                        var detail = new ConstructionFieldNameDetail(
+                                                            0,
+                                                            (int)rowData.Cells[(int)ColumnIndex.ConstructionCode].Value,
+                                                            (string)rowData.Cells[(int)ColumnIndex.ConstructionName].Value,
+                                                            CommonMotions.cnvInt(rowData.Cells[(int)ColumnIndex.BillPrice].Value),
+                                                            false,
+                                                            false,
+                                                            true
+                        );
+
+                        m_ConstructionFieldNameHeader.ConstructionFieldNameDetails.Add(detail);
+
+                    }
+                }
+
+                // 不明行データの処理
+                if (m_HtDetailLineCount.ContainsKey(0))
+                {
+                    // 不明データが存在する場合は、不明行の金額をセットする
+                    ((ConstructionFieldNameDetail)m_HtDetailLineCount[0]).BillPrice = (int)dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value;
+                    if (CommonMotions.cnvInt(dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value) == 0)
+                    {
+                        // 不明金額が0の場合は、削除フラグをtrueにする
+                        ((ConstructionFieldNameDetail)m_HtDetailLineCount[0]).DeleteFlag = true;
+                    }
+                }
+                else if((int)dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value != 0)
+                {
+                    // 不明データが存在しないが、不明金額が0ではない場合、不明データを追加する
+                    m_ConstructionFieldNameHeader.ConstructionFieldNameDetails.Add(
+                        new ConstructionFieldNameDetail(
+                            //1,                                                                      // LineCount(不明なので1で固定)
+                            0,                                                                      // LineCount(不明なので1で固定)
+                            0,                                                                      // 現場コード
+                            "不明",                                                                       // 現場名
+                            CommonMotions.cnvInt(dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value)));  // 金額
+                }
+
+                // 結果をOKにして画面を閉じる
+                m_EndButton = DialogResult.OK;
+                this.Close();
+            }
+            catch(Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+
+        }
+        #endregion
+
+        #region 終了ボタン押下
+        /// <summary>
+        /// 終了ボタン押下
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void btnEnd_Click(object sender, EventArgs e)
+        {
+            try
+            {
+                m_EndButton = DialogResult.No;
+                this.Close();
+            }
+            catch(Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 一覧選択行変更時処理
+        /// <summary>
+        /// 一覧選択行変更時処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgv1_SelectionChanged(object sender, EventArgs e)
+        {
+            try
+            {
+                if (dgv1.SelectedRows.Count != 0)
+                {
+                    btnDelete.Enabled = true;
+                    foreach (DataGridViewRow gridRow in dgv1.SelectedRows)
+                    {
+                        // 選択された行のReadOnlyカラム(非表示)を参照して、trueの場合は削除ボタンを無効、falseの場合は有効にする
+                        btnDelete.Enabled &= !((bool)gridRow.Cells[(int)ColumnIndex.ReadOnly].Value);
+                    }
+                }
+                else
+                {
+                    // 選択行が一つもない場合は、削除ボタンを無効にする
+                    btnDelete.Enabled = false;
+                }
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region Gridセル値変更時処理
+        /// <summary>
+        /// Gridセル値変更時処理
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgv1_CellValueChanged(object sender, DataGridViewCellEventArgs e)
+        {
+            try
+            {
+                // 行が追加されたときではなく、セルの内容が変更されているときだけ処理を実行する。また金額以外の変更は処理を抜ける。
+                if (e.RowIndex == dgv1.NewRowIndex || !dgv1.IsCurrentCellDirty || e.ColumnIndex != (int)ColumnIndex.BillPrice)
+                {
+                    return;
+                }
+
+                var targetCell = dgv1.Rows[e.RowIndex].Cells[e.ColumnIndex] as DataGridViewCell;
+                // 対象セルの値がstringのときに処理を行う
+                if (targetCell.Value.GetType() == typeof(string))
+                {
+                    // stringをintへparseしてセットしなおす
+                    int dest = 0;
+                    int.TryParse((string)targetCell.Value, out dest);
+                    targetCell.Value = dest;
+                }
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 初期表示処理
+        /// <summary>
+        /// 初期表示処理
+        /// </summary>
+        private void InitDataLoad()
+        {
+            try
+            {
+                // 業者名を表示
+                tboxCompany.Text = m_ConstructionFieldNameHeader.CompanyName;
+
+                // 一覧表示
+                ItemListDisplay();
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 不明金額を再計算して表示
+        /// <summary>
+        /// 不明金額の再計算および表示
+        /// </summary>
+        private void CalcUnknownBillPrice()
+        {
+            try
+            {
+                // 請求金額合計を取得
+                m_UnknownReservedPrice = m_ConstructionFieldNameHeader.BillPrice;
+
+                for (int rowIndex = 0; rowIndex < dgv1.RowCount - 1; rowIndex++)
+                {
+                    // 表の他担当者割当済金額と現場毎の金額を差し引く
+                    m_UnknownReservedPrice -= CommonMotions.cnvInt(dgv1.Rows[rowIndex + 1].Cells[(int)ColumnIndex.BillPrice].Value);
+                }
+
+                // 不明行の金額欄に値をセット
+                dgv2.Rows[0].Cells[(int)ColumnIndex.BillPrice].Value = m_UnknownReservedPrice;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 現場一覧表の表示 
+        /// <summary>
+        /// 現場一覧表表示
+        /// </summary>
+        private void ItemListDisplay()
+        {
+            try
+            {
+                // 一旦セルの値変更と行選択変更イベントを無効にする
+                dgv1.CellValueChanged -= dgv1_CellValueChanged;
+                dgv1.SelectionChanged -= dgv1_SelectionChanged;
+
+                // DataGridを一旦クリア
+                dgv1.Rows.Clear();
+                dgv2.Rows.Clear();
+
+                // 金額行のフォーマットを指定
+                //dgv1.Columns[(int)ColumnIndex.BillPrice].DefaultCellStyle.Format = "#,0";
+                dgv2.Columns[(int)ColumnIndex.BillPrice].DefaultCellStyle.Format = "#,0";
+
+                // 他担当の現場割当済金額を算出
+                int reservedPrice = m_ConstructionFieldNameHeader.BillPrice;
+                foreach (var detail in m_ConstructionFieldNameHeader.ConstructionFieldNameDetails)
+                {
+                    reservedPrice -= detail.BillPrice;
+                }
+
+                // 請求書金額行を追加
+                dgv1.Rows.Add(0, "", "請求書金額", m_ConstructionFieldNameHeader.BillPrice, true);
+                dgv1.Rows[dgv1.RowCount - 1].DefaultCellStyle.BackColor = Color.Yellow;
+                dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+
+
+                //　他担当の現場割当済行を追加
+                dgv1.Rows.Add(0, "", "他担当の現場割当済", reservedPrice, true);
+                dgv1.Rows[dgv1.RowCount - 1].DefaultCellStyle.BackColor = Color.Yellow;
+                dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+
+                // 不明の行を追加
+                dgv2.Rows.Add(0, "", "不明", 0);
+
+                // 各現場の行を追加
+                int rowCount = 0;
+                foreach (var detail in m_ConstructionFieldNameHeader.ConstructionFieldNameDetails)
+                {
+                    if(detail.ConstructionCode != 0 )
+                    {
+                        // 各個現場の行を追加
+                        dgv1.Rows.Add(detail.ConstructionCode, ++rowCount, detail.FieldName, detail.BillPrice, detail.ReadOnly);
+                        dgv1.Rows[dgv1.RowCount - 1].Resizable = DataGridViewTriState.False;
+                        dgv1.Rows[dgv1.RowCount - 1].Cells[(int)ColumnIndex.BillPrice].ReadOnly = detail.ReadOnly;         // ReadOnlyフラグがtrueなら金額のセルを編集不可にする
+                    }
+
+                    // ハッシュテーブルの追加
+                    //m_HtDetailLineCount.Add(detail.LineCount, detail); //Update Mjurakami
+                    m_HtDetailLineCount.Add(detail.ConstructionCode, detail);
+                    m_HtGridRowConstructionCode.Add(detail.ConstructionCode, dgv1.Rows[dgv1.RowCount - 1]);
+                }
+
+                // 不明行を再計算して表示
+                CalcUnknownBillPrice();
+
+                // イベントハンドラ再登録
+                dgv1.CellValueChanged += dgv1_CellValueChanged;
+                dgv1.SelectionChanged += dgv1_SelectionChanged;
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+
+        #endregion
+
+        /// <summary>
+        /// CellBeginEdit
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgv1_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
+        {
+            DataGridView dgv = (DataGridView)sender;
+
+            if (e.ColumnIndex == (int)ColumnIndex.BillPrice)
+            {
+                dgv[e.ColumnIndex, e.RowIndex].Value = CommonMotions.cnvInt(dgv[e.ColumnIndex, e.RowIndex].Value);
+                dgv[e.ColumnIndex, e.RowIndex].Style.ForeColor = SystemColors.ControlText;
+
+            }
+        }
+
+        /// <summary>
+        /// CellFormatting
+        /// </summary>
+        /// <param name="sender"></param>
+        /// <param name="e"></param>
+        private void dgv1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
+        {
+            DataGridView dgv = (DataGridView)sender;
+
+            try
+            {
+                if (dgv.RowCount == 0)
+                    return;
+
+                if (e.ColumnIndex == (int)ColumnIndex.BillPrice)
+                {
+                    // マイナス値は赤
+                    if (CommonMotions.cnvInt(dgv[e.ColumnIndex, e.RowIndex].Value) < 0)
+                    {
+                        dgv[e.ColumnIndex, e.RowIndex].Style.ForeColor = Color.Red;
+                    }
+                    else
+                    {
+                        dgv[e.ColumnIndex, e.RowIndex].Style.ForeColor = SystemColors.ControlText;
+                    }
+
+                    dgv[e.ColumnIndex, e.RowIndex].Value = CommonMotions.cnvInt(dgv[e.ColumnIndex, e.RowIndex].Value).ToString("#,0");
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+    }
+}
